package edu.whs.spin2018.baoapp.views.menues;

import android.content.Context;
import android.os.Bundle;
import android.support.annotation.Nullable;
import android.support.v4.app.DialogFragment;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;

import edu.whs.spin2018.baoapp.R;

/**
 * A simple {@link DialogFragment} subclass. Activities that contain this fragment must implement
 * the {@link OnAuswahlGetroffenListener} interface to handle interaction events. Use the {@link
 * SpieleinstellungenVerlassenDialog#newInstance} factory method to create an instance of this
 * fragment.
 */
public class SpieleinstellungenVerlassenDialog extends DialogFragment {
    private static final String TAG = "SpieleinstellungenVTAG";

    private OnAuswahlGetroffenListener mListener;

    public SpieleinstellungenVerlassenDialog() {
        // Required empty public constructor
    }

    /**
     * Use this factory method to create a new instance of this fragment using the provided
     * parameters.
     *
     * @return A new instance of fragment SpieleinstellungenVerlassenDialog.
     */
    // TODO: Rename and change types and number of parameters
    public static SpieleinstellungenVerlassenDialog newInstance() {
        SpieleinstellungenVerlassenDialog fragment = new SpieleinstellungenVerlassenDialog();
        Bundle args = new Bundle();
        fragment.setArguments(args);
        return fragment;
    }

    @Override
    public void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setStyle(DialogFragment.STYLE_NO_TITLE, R.style.DialogAbgerundeteEcken);
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {

        View view = inflater.inflate(R.layout.fragment_spieleinstellungen_verlassen_dialog, container, false);

        Button btnJa = view.findViewById(R.id.spieleinstellungen_btn_ja);
        Button btnNein = view.findViewById(R.id.spieleinstellungen_btn_nein);

        btnJa.setOnClickListener((v) -> {
            Log.d(TAG, "onCreateView: btnJa clicked");
            mListener.onVerlassenBestaetigt();
            dismissAllowingStateLoss();
        });

        btnNein.setOnClickListener((v) -> {
            mListener.onVerlassenAbgebrochen();
            dismissAllowingStateLoss();
        });

        // Inflate the layout for this fragment
        return view;
    }

    @Override
    public void onAttach(Context context) {
        super.onAttach(context);
        if (context instanceof OnAuswahlGetroffenListener) {
            mListener = (OnAuswahlGetroffenListener) context;
        } else {
            throw new RuntimeException(context.toString()
                    + " must implement OnAuswahlGetroffenListener");
        }
    }

    @Override
    public void onDetach() {
        super.onDetach();
        mListener = null;
    }

    /**
     * This interface must be implemented by activities that contain this fragment to allow an
     * interaction in this fragment to be communicated to the activity and potentially other
     * fragments contained in that activity.
     * <p>
     * See the Android Training lesson <a href= "http://developer.android.com/training/basics/fragments/communicating.html"
     * >Communicating with Other Fragments</a> for more information.
     */
    public interface OnAuswahlGetroffenListener {

        /**
         * Teilt der Activity mit, dass die Spieleinstellungen verlassen werden sollen.
         */
        void onVerlassenBestaetigt();

        /**
         * Teilt der Activity mit, dass die Spieleinstellungen nicht verlassen werden sollen.
         */
        void onVerlassenAbgebrochen();
    }
}
